.terraform_s3_bucket:
  stage: .pre
  allow_failure: true
  needs: []
  image: $CI_TEMPLATE_REGISTRY_HOST/gitlab-org/terraform-images/stable:latest
  variables:
    TF_ROOT: $CI_PROJECT_DIR/terraform-s3-bucket
    TF_STATE_NAME: $ENVIRONMENT
    TF_VAR_ENVIRONMENT: $ENVIRONMENT
    TF_VAR_PROJECT_NAME: $PROJECT_NAME
    TF_VAR_REPOSITORY_NAME: $CI_PROJECT_NAME
  before_script:
    - git clone https://gitlab.com/ibisdev.tech/ci-addons/terraform-s3-bucket.git
    - cd $TF_ROOT

    - source gitlab-terraform init
  script:
    - terraform apply -auto-approve

    - git clone https://gitlab.com/ibisdev.tech/ci-addons/create-ci-variables.git
    - cp create-ci-variables/*-variable /usr/bin
    - chmod +x /usr/bin/*-variable

    - create-variable "K8S_SECRET_AWS_REGION" "us-east-1" "*"
    - create-variable "K8S_SECRET_AWS_ACCESS_KEY_ID" "$(terraform output --raw iam_access_key_id)" "$ENVIRONMENT"
    - create-variable "K8S_SECRET_AWS_SECRET_ACCESS_KEY" "$(terraform output --raw iam_secret_access_key)" "$ENVIRONMENT"
    - create-variable "K8S_SECRET_BUCKET_NAME" "$(terraform output --raw s3_bucket_id)" "$ENVIRONMENT"
    - create-variable "K8S_SECRET_CLOUDFRONT_DOMAIN_NAME" "$(terraform output --raw cloudfront_distribution_domain_name)" "$ENVIRONMENT"
    - delete-variable "ADDONS_CREATE_BUCKET"

terraform_s3_bucket_dev:
  extends: .terraform_s3_bucket
  variables:
    ENVIRONMENT: dev
  rules:
    - if: $ADDONS_CREATE_BUCKET && $DEV_ENABLED && $CI_COMMIT_REF_PROTECTED == "true"

terraform_s3_bucket_qa:
  extends: .terraform_s3_bucket
  variables:
    ENVIRONMENT: qa
  rules:
    - if: $ADDONS_CREATE_BUCKET && $QA_ENABLED && $CI_COMMIT_REF_PROTECTED == "true"

terraform_s3_bucket_staging:
  extends: .terraform_s3_bucket
  variables:
    ENVIRONMENT: staging
  rules:
    - if: $STAGING_DISABLED
      when: never
    - if: $ADDONS_CREATE_BUCKET && $CI_COMMIT_REF_PROTECTED == "true"

terraform_s3_bucket_production:
  extends: .terraform_s3_bucket
  variables:
    ENVIRONMENT: production
  rules:
    - if: $PRODUCTION_DISABLED
      when: never
    - if: $ADDONS_CREATE_BUCKET && $CI_COMMIT_REF_PROTECTED == "true"
